uniform lowp mat4 ColorMatrix; // Android

#ifdef DCC_MAX
	#define DCC( x ) x 
#else
	#define DCC( x )
#endif

varying lowp vec4 vColor DCC(: COLOR0);
varying	mediump vec2 vCoord DCC(: TEXCOORD0);

uniform lowp sampler2D DiffuseSampler;
uniform lowp sampler2D DiffuseSampler_alpha; // Android

#define TONED
#ifdef TONED
	uniform lowp vec3 ToneGain;
	uniform lowp vec3 ToneOffset;
#endif

void main()
{
	//lowp vec4 Diffuse = texture2D(DiffuseSampler, vCoord); // Android
	lowp vec4 Diffuse = vec4( texture2D(DiffuseSampler, vCoord).rgb, texture2D(DiffuseSampler_alpha, vCoord).g ) ; // Android
	
	lowp vec4 color = vColor * Diffuse;
	
#ifdef TONED	
	color.rgb = color.rgb * ToneGain + ToneOffset;
#endif
    gl_FragColor = color;
}
