uniform lowp    sampler2D texture0;
uniform lowp   vec3 bloomThreshold;
uniform lowp   vec3 sceneFactor;
uniform lowp   vec3 bloomFactor;

varying mediump vec2 vCoord0;

void main()
{
	lowp vec4 color = texture2D(texture0, vCoord0);
	lowp vec4 bloom = color;

    bloom.rgb -= bloomThreshold;
	bloom = max(vec4(0.0), bloom);
	
	color.rgb = color.rgb * sceneFactor + bloom.rgb * bloomFactor;
    gl_FragColor = color;
}
