uniform lowp mat4 ColorMatrix; // Android

uniform lowp sampler2D texture0;
uniform lowp sampler2D texture1;

uniform lowp sampler2D texture0_alpha; // Android
uniform lowp sampler2D texture1_alpha; // Android

varying highp vec2 vCoord0;
varying highp vec2 vCoord1;

void main()
{
	highp vec4 c1 = texture2D(texture0, vCoord0);
	highp vec4 c2 = texture2D(texture1, vCoord1);
	
	c1.a = texture2D(texture0_alpha, vCoord0).r; // Android
	c2.a = texture2D(texture1_alpha, vCoord1).r; // Android
	
	highp vec4 color = min(c1 + c2, 1.0);
	
    gl_FragColor = color;
}
