uniform lowp sampler2D texture0;
varying highp vec2 texCoord0;

uniform lowp float brightnessOffset;
uniform lowp float contrastFactor;
uniform mediump float bloomSaturation;
uniform lowp vec3 bloomDesat;

void main()
{
	lowp vec3 c = texture2D(texture0, texCoord0).rgb;
	
	lowp vec3 hilite = clamp(c+brightnessOffset, 0.0, 1.0);
	hilite = clamp(hilite*contrastFactor, 0.0, 1.0);
	
	lowp vec3 desat = vec3(dot(bloomDesat, hilite));
	gl_FragColor = vec4(mix(hilite.rgb, desat, bloomSaturation),1.0);
}


