attribute highp   vec4 Vertex;
attribute mediump vec2 TexCoord0;

uniform   highp   mat4 WorldViewProjectionMatrix;

uniform mediump float blurFactor;

varying mediump vec2 vCoord0;
varying mediump vec2 vCoordL1;
varying mediump vec2 vCoordL2;
varying mediump vec2 vCoordL3;
varying mediump vec2 vCoordL4;
varying mediump vec2 vCoordR1;
varying mediump vec2 vCoordR2;
varying mediump vec2 vCoordR3;
varying mediump vec2 vCoordR4;

uniform mediump vec4 clampRange;
void main(void)
{
	gl_Position = Vertex;
	
	vCoord0 = TexCoord0;

#ifdef HORIZONTAL
	//vCoordL4 = vec2(max(0.0, TexCoord0.x - 4.0*blurFactor), TexCoord0.y);
	//vCoordL3 = vec2(TexCoord0.x - 3.0*blurFactor, TexCoord0.y);
	vCoordL2 = clamp(vec2(TexCoord0.x - 2.0*blurFactor, TexCoord0.y), clampRange.xy, clampRange.zw);
	vCoordL1 = clamp(vec2(TexCoord0.x - blurFactor, TexCoord0.y), clampRange.xy, clampRange.zw);
	vCoordR1 = clamp(vec2(TexCoord0.x + blurFactor, TexCoord0.y), clampRange.xy, clampRange.zw);
	vCoordR2 = clamp(vec2(TexCoord0.x + 2.0*blurFactor, TexCoord0.y), clampRange.xy, clampRange.zw);
	//vCoordR3 = vec2(TexCoord0.x + 3.0*blurFactor, TexCoord0.y);
	//vCoordR4 = vec2(min(0.99, TexCoord0.x + 4.0*blurFactor), TexCoord0.y);
#else
	//vCoordL4 = vec2(TexCoord0.x, max(0.0, TexCoord0.y - 4.0*blurFactor));
	//vCoordL3 = vec2(TexCoord0.x, TexCoord0.y - 3.0*blurFactor);
	vCoordL2 = clamp(vec2(TexCoord0.x, TexCoord0.y - 2.0*blurFactor), clampRange.xy, clampRange.zw);
	vCoordL1 = clamp(vec2(TexCoord0.x, TexCoord0.y - blurFactor), clampRange.xy, clampRange.zw);
	vCoordR1 = clamp(vec2(TexCoord0.x, TexCoord0.y + blurFactor), clampRange.xy, clampRange.zw);
	vCoordR2 = clamp(vec2(TexCoord0.x, TexCoord0.y + 2.0*blurFactor), clampRange.xy, clampRange.zw);
	//vCoordR3 = vec2(TexCoord0.x + 3.0*blurFactor, TexCoord0.y);
	//vCoordR3 = vec2(TexCoord0.x, TexCoord0.y + 3.0*blurFactor);
	//vCoordR4 = vec2(TexCoord0.x, min(0.99, TexCoord0.y + 4.0*blurFactor));
#endif

}
