uniform lowp sampler2D texture0;
uniform highp sampler2D depthTexture;

uniform highp float focus;
uniform highp float scale;
uniform highp float range;
uniform highp float rangeClear;

varying mediump vec2 vCoord0;
varying mediump vec2 vCoord1;
varying mediump vec2 vCoord2;
varying mediump vec2 vCoord3;
varying mediump vec2 vCoord4;

uniform highp vec4 depthInfo;

void main()
{
	mediump vec4 c0 = texture2D(texture0, vCoord0);
	mediump vec4 c1 = texture2D(texture0, vCoord1);
	mediump vec4 c2 = texture2D(texture0, vCoord2);
	mediump vec4 c3 = texture2D(texture0, vCoord3);
	mediump vec4 c4 = texture2D(texture0, vCoord4);
	
	mediump float normalizeFactor = 1.0 / 5.0;
	
	mediump vec4 color;
	color.xyz = c0.xyz + c1.xyz + c2.xyz + c3.xyz + c4.xyz;
	color.xyz *= normalizeFactor;
	
	highp float z = texture2D(depthTexture, vCoord0).r;
	z = min((z - depthInfo.z) * depthInfo.w, 1.0);
	z = depthInfo.x / (z - depthInfo.y);

	highp float w = scale * clamp(range * (abs(focus - z) - rangeClear), 0.0, 1.0);

	color.a = w;
	
	gl_FragColor = color;
}
