uniform lowp mat4 ColorMatrix; // Android

//#define ADDITIVE
//#define DIFFUSE_TINT
//#define TONED

uniform sampler2D 	MasksSampler;
uniform sampler2D 	MasksSampler_alpha; // Android

#ifdef SPLIT_ALPHA
uniform sampler2D 	MasksSampler;
#endif

uniform lowp 	vec4 		DiffuseTint;

// Forcing Tone offset and gain temporarily on all effects.
//#define TONED
#ifdef TONED
uniform lowp 	vec3 		ToneGain;
uniform lowp 	vec3 		ToneOffset;
#endif

// == Interpolators 	== //
varying   	mediump 	vec2 vCoord0;
varying		mediump		vec2 vOffsetMapCoord0;
varying		mediump		vec2 vOffsetMapCoord1;
varying		mediump		vec2 vVerticalRamp;
varying		mediump		vec2 vGridUV;
varying		mediump		vec2 vCoord1;
varying   	lowp		vec4 vColor;

void main()
{
	//lowp vec4 OffsetMap0 = texture2D(MasksSampler, vOffsetMapCoord0); // Android
	lowp vec4 OffsetMap0 = vec4( texture2D(MasksSampler, vOffsetMapCoord0).rgb, texture2D(MasksSampler_alpha, vOffsetMapCoord0).g ) ; // Android
	
	OffsetMap0.r *= 0.3;
	
	lowp vec2 OffsetMap1 = vec2(0.5,0.75)*vOffsetMapCoord0;
	OffsetMap1 += OffsetMap0.r;	
	OffsetMap1 += vOffsetMapCoord1;
		
	lowp vec4 ColorMap = (texture2D(MasksSampler, OffsetMap1).r + 0.45) * vColor;
	//lowp float Grid = (texture2D(MasksSampler, vGridUV)).g ;

	lowp vec4 final	= ColorMap* float(3);// *vVerticalRamp.g;

	// Diffuse color should always be white. This is just for compatibility reasons.
	// For color tinting use DiffuseTint;

 #ifdef DIFFUSE_TINT
 	final	*= DiffuseTint;
 #endif
	

#ifdef TONED
	final.rgb = final.rgb * ToneGain + ToneOffset * final.a;
#endif


	gl_FragColor = final;
}