//#define ADDITIVE
//#define DIFFUSE_TINT
//#define TONED

// == Vertex Attributes == //
attribute 	highp   	vec4 Vertex;
attribute 	mediump 	vec2 TexCoord0;
attribute 	lowp		vec4 Color;

// == Uniform variables == //
uniform   	highp		mat4 WorldViewProjectionMatrix;
uniform		mediump		vec4 MaskSampler_scaleoffset;

uniform		highp		float time;
uniform		highp		float MyGlobalTime;
uniform		lowp		float GridTiling;


#ifdef DIFFUSE_COLOR
uniform lowp			vec4 DiffuseColor;
#endif

#ifdef UV
uniform		mediump		vec2 UVOffset;
#endif

// == Interpolators 	== //
varying   	mediump 	vec2 vCoord0;
varying		mediump		vec2 vOffsetMapCoord0;
varying		mediump		vec2 vOffsetMapCoord1;
varying		mediump		vec2 vVerticalRamp;
//varying		mediump		vec2 vGridUV;
varying   	lowp		vec4 vColor;

void main()
{
		
	vColor         		= Color;
	
	vec2 tCoord0   		= TexCoord0;
	vOffsetMapCoord0 	= tCoord0;
	vOffsetMapCoord1 	= vOffsetMapCoord0;
	vVerticalRamp 		= vOffsetMapCoord0*vOffsetMapCoord0;
	
	//vGridUV = tCoord0*GridTiling;
	
	vOffsetMapCoord0 += vec2(-0.1,0.2)* MyGlobalTime;// *vColor.a;
	
	vOffsetMapCoord1 += vec2(0.015,0.1)* MyGlobalTime;// *vColor.a;
	
	
	
	
	vec4 position  =  	WorldViewProjectionMatrix * Vertex;
	
#ifdef DIFFUSE_COLOR
	vColor		  *= DiffuseColor;
#endif


	gl_Position    = position;
}