//#define ADDITIVE
//#define DIFFUSE_TINT
//#define TONED


// == Vertex Attributes == //
attribute 	highp   	vec4 Vertex;
attribute 	mediump 	vec2 TexCoord0;
attribute	mediump		vec2 TexCoord1;
attribute 	lowp		vec4 Color;

// == Uniform variables == //
uniform   	highp		mat4 WorldViewProjectionMatrix;
uniform 	mediump 	vec4 DiffuseSampler_scaleoffset;
uniform		mediump		vec4 MaskSampler_scaleoffset;

uniform		mediump		vec2 MaskPanSpeed;			// Pan Speed.

//uniform		highp		float time;
uniform		highp		float MyGlobalTime;
uniform		mediump		float GridTiling;


#ifdef DIFFUSE_COLOR
uniform lowp			vec4 DiffuseColor;
#endif

#ifdef UV
uniform		mediump		vec2 UVOffset;
uniform		mediump		vec2 UVMaskOffset;	
#endif

// == Interpolators 	== //
varying   	mediump 	vec2 vCoord0;
varying		mediump		vec2 vOffsetMapCoord0;
varying		highp		vec2 vOffsetMapCoord1;
varying		highp		vec2 vOffsetMapCoord2;
varying		mediump		vec2 vGridUV;
varying		highp		vec2 vStarsUV;
varying		mediump		float vTimer;
varying   	lowp		vec4 vColor;

void main()
{

	vec2 tCoord0   	= TexCoord0;// * DiffuseSampler_scaleoffset.xy + DiffuseSampler_scaleoffset.zw;
	vOffsetMapCoord0 = tCoord0;
	vOffsetMapCoord1 = vOffsetMapCoord0;
	vOffsetMapCoord2 = vOffsetMapCoord0;
	
	vGridUV = tCoord0*GridTiling;
	
	vStarsUV = vOffsetMapCoord0*vec2(0.25,1);
	vStarsUV += vec2(0.5,0) * MyGlobalTime;
	
	vOffsetMapCoord1 *= 0.5;
	vOffsetMapCoord1 += vec2(0.03,0.01)*MyGlobalTime;
	
	vOffsetMapCoord2 *= 0.14;
	vOffsetMapCoord2 += vec2(-0.1,-0.034)*MyGlobalTime;
	
	vColor         = Color;
	
	vTimer = clamp(sin(MyGlobalTime*float(0.25))*float(2),0.0,2.0);
	
	vec4 position  =  	WorldViewProjectionMatrix * Vertex;
	
#ifdef DIFFUSE_COLOR
	vColor		  *= DiffuseColor;
#endif


	gl_Position    = position;
}