//#define ADDITIVE
//#define DIFFUSE_TINT
//#define TONED

// == Vertex Attributes == //
attribute 	highp   	vec4 Vertex;
attribute 	mediump 	vec2 TexCoord0;
attribute	mediump		vec2 TexCoord1;
attribute 	lowp		vec4 Color;


// == Uniform variables == //
uniform   	highp		mat4 WorldViewProjectionMatrix;
uniform 	mediump 	vec4 DiffuseSampler_scaleoffset;
uniform		mediump		vec4 MaskSampler_scaleoffset;

uniform		mediump		vec2 MaskPanSpeed;			// Pan Speed.
uniform		highp		float MyGlobalTime;


#ifdef DIFFUSE_COLOR
uniform lowp			vec4 DiffuseColor;
#endif

#ifdef UV
uniform		mediump		vec2 UVOffset;
uniform		mediump		vec2 UVMaskOffset;	
#endif

// == Interpolators 	== //
varying   	mediump 	vec2 vCoord0;
varying		highp		vec2 vCoord1;
varying   	lowp		vec4 vColor;

void main()
{

	vec2 tCoord0   	= TexCoord0;// * DiffuseSampler_scaleoffset.xy + DiffuseSampler_scaleoffset.zw;
	vec2 tCoord1   	= TexCoord1;// * MaskSampler_scaleoffset.xy + MaskSampler_scaleoffset.zw;
#ifdef UV	
	tCoord0       += UVOffset;
	tCoord1		  += UVMaskOffset;
#endif

	vCoord0        = tCoord0;
	vCoord1		   = tCoord1 + MaskPanSpeed * MyGlobalTime;
	vColor         = Color;
	
	
	vec4 position  =  	WorldViewProjectionMatrix * Vertex;
	
#ifdef DIFFUSE_COLOR
	vColor		  *= DiffuseColor;
#endif


	gl_Position    = position;
}