//#define ADDITIVE
//#define DIFFUSE_TINT
//#define TONED
//#define MASK2


// == Vertex Attributes == //
attribute 	highp   	vec4 Vertex;
attribute 	mediump 	vec2 TexCoord0;

#ifdef MASK2
attribute	mediump		vec2 TexCoord1;
#endif

attribute 	lowp		vec4 Color;

// == Uniform variables == //
uniform   	highp		mat4 WorldViewProjectionMatrix;
uniform 	mediump 	vec4 DiffuseSampler_scaleoffset;
uniform		mediump		vec4 MaskSampler_scaleoffset;

// Panning/Scaling of coordinates.
//uniform		mediump		vec2 MaskPanSpeed;			// Pan Speed.
uniform		mediump		vec2 MapCoord1Speed;			// = vec2(0.03,0.01);
uniform		mediump		vec2 MapCoord2Speed;			// = vec2(-0.1,-0.034);

uniform		mediump		vec2 MapCoord1Scale;			// = vec2(0.5, 0.5);
uniform		mediump		vec2 MapCoord2Scale;			// = vec2(0.14, 0.14);

#ifdef MASK2
uniform		mediump		vec2 UVMask2Offset;
uniform		mediump		vec2 UVMask2Speed;
#endif

// Time value
//uniform		highp		float time;
uniform		highp		float MyGlobalTime;
uniform		highp		float time;

uniform		lowp		float GridTiling;


#ifdef DIFFUSE_COLOR
uniform lowp			vec4 DiffuseColor;
#endif

#ifdef UV
uniform		mediump		vec2 UVOffset;
uniform		mediump		vec2 UVMaskOffset;	
#endif

// == Interpolators 	== //
varying   	mediump 	vec2 vCoord0;

#ifdef MASK2
varying		mediump		vec2 vCoord2;
#endif

varying		highp		vec2 vOffsetMapCoord0;
varying		highp		vec2 vOffsetMapCoord1;
varying		highp		vec2 vOffsetMapCoord2;
//varying		mediump		vec2 vCoord1;
varying   	lowp		vec4 vColor;

void main()
{

	vec2 tCoord0   	= TexCoord0;// * DiffuseSampler_scaleoffset.xy + DiffuseSampler_scaleoffset.zw;
	vOffsetMapCoord0 = tCoord0;
	vOffsetMapCoord1 = vOffsetMapCoord0;
	vOffsetMapCoord2 = vOffsetMapCoord0;
	
	
	vOffsetMapCoord1 *= MapCoord1Scale;
	vOffsetMapCoord1 += MapCoord1Speed * time;
	
	vOffsetMapCoord2 *= MapCoord2Scale;
	vOffsetMapCoord2 += MapCoord2Speed * time;
	
#ifdef MASK2
	vec2 tCoord2				= TexCoord1;
	vCoord2					 	= tCoord2 + UVMask2Offset + UVMask2Speed * time;
#endif

	vColor         = Color;

	vec4 position  =  	WorldViewProjectionMatrix * Vertex;
	

	gl_Position    = position;
}