//#define OA				// For controlling the object's alpha with the parameter "Object_Alpha"
//#define DIFFUSE_COLOR

attribute 	highp   	vec4 Vertex;
attribute 	mediump 	vec2 TexCoord0;
attribute 	lowp		vec4 Color;

uniform   	highp		mat4 WorldViewProjectionMatrix;
uniform   	mediump		vec2 UVTiling; 
uniform   	mediump		vec2 UVShearing;
uniform 	mediump		vec2 UVOffset;
uniform 	mediump 	vec2 UVAOffset;
uniform 	lowp 		vec4 DiffuseColor;
#ifdef OA
uniform		lowp		float Object_Alpha;
#endif

varying   	mediump 	vec2 vCoord0;
varying   	lowp		vec4 vColor;
varying	  	mediump		vec2 vCoord1;

void main()
{
	//mediump vec2 tCoord = vec2(TexCoord0.y, TexCoord0.x) ;
	gl_Position    = WorldViewProjectionMatrix * Vertex;
	vCoord0        = TexCoord0 + UVOffset;
	vCoord1		   = TexCoord0 + UVAOffset;		// No point in precomputing TexCoord0 * UVTiling first.
	vColor         = Color  * DiffuseColor;
	
#ifdef OA
	vColor.a	  *= Object_Alpha;
#endif
}