attribute highp   vec4 Vertex;
attribute mediump vec2 TexCoord0;

uniform highp float Time;

uniform highp mat4 WorldViewProjectionMatrix;

varying highp vec2 vBaseUV;
varying highp vec2 vNormalUV;
varying highp vec2 vFactorUV;

uniform mediump vec2 speed;
uniform mediump float tiling;

uniform mediump float factor_offset;

uniform mediump vec2 normal_uv_factor;

uniform mediump vec4 scaleoffset;

void main(void)
{
	gl_Position = Vertex;
	
	vBaseUV = TexCoord0;
	
	vFactorUV = vBaseUV;
	vFactorUV.y += factor_offset;
	vNormalUV = (TexCoord0 * tiling + Time * speed) * normal_uv_factor;
	vBaseUV = vBaseUV * scaleoffset.xy + scaleoffset.zw;
}
