#ifdef DCC_MAX
	#define DCC(x) x
#else
	#define DCC(x)
#endif

//#define FG

#if defined AT
	uniform lowp float alpharef;
#endif

varying mediump vec2 vTexCoord0 DCC(: TEXCOORD0);

varying lowp vec4 vColor DCC(: COLOR0);

uniform lowp sampler2D DiffuseSampler;

#if defined (AL) || defined (AB)
	uniform lowp float Object_Alpha;
#endif

#ifdef FG
	varying lowp float vFogFactor;
	uniform lowp vec4 fogcolor;   
#endif

uniform lowp vec4 sunFactor;

#define TONED
#ifdef TONED
	uniform lowp vec3 ToneGain;
	uniform lowp vec3 ToneOffset;
#endif

void main()
{
	lowp vec4 Diffuse = texture2D(DiffuseSampler, vTexCoord0);

#ifdef AT
	if (Diffuse.w < alpharef) discard;	
#endif

	lowp vec4 color = vColor * Diffuse;

#ifdef AL
	color.a *= Object_Alpha;
#endif

#ifdef AB
	color.rgb *= Object_Alpha;
#endif

	color.rgb += sunFactor.rgb;

#ifdef FG
	color.xyz = mix(color.xyz, fogcolor.xyz, vFogFactor);
#endif

#ifdef TONED	
	color.rgb = color.rgb * ToneGain + ToneOffset;
#endif

	gl_FragColor = clamp(color, 0.0, 1.0);
} // main end
