uniform lowp mat4 ColorMatrix; // Android

#ifdef DCC_MAX
	#define DCC(x) x
#else
	#define DCC(x)
#endif

//#define FG

uniform sampler2D Diffuse;
uniform sampler2D Diffuse_alpha; // Android
uniform lowp float Object_Alpha;

// Varyings
varying mediump vec2 vTexCoord0 DCC(: TEXCOORD0);
varying lowp vec4 vColor DCC(: COLOR0);

#ifdef FG
	varying lowp float vFogFactor;
	uniform lowp vec4 fogcolor;   
#endif

void main()
{
    lowp vec4 DiffuseColor;
    //DiffuseColor = texture2D(Diffuse, vTexCoord0.xy); // Android
	DiffuseColor = vec4( texture2D(Diffuse, vTexCoord0.xy).rgb, texture2D(Diffuse_alpha, vTexCoord0.xy).g ) ; // Android
    
    
    lowp vec4 color = DiffuseColor * (Object_Alpha * vColor.a);
    
#ifdef FG
#ifdef ADDITIVE_BLENDING
	color.xyz = mix(color.xyz, vec3(0.0, 0.0, 0.0), vFogFactor);
	color *= (1.0 - vFogFactor);
#else // ADDITIVE_BLENDING
	color.xyz = mix(color.xyz, fogcolor.xyz, vFogFactor);
#endif // ADDITIVE_BLENDING
#endif // FG
    
    gl_FragColor = color;
}
