#ifdef DCC_MAX
	#define DCC(x) x
#else
	#define DCC(x)
#endif

//#define FG

#ifdef GLOBALFADE
	uniform highp float GlobalFade;
#endif

uniform highp mat4 WorldViewProjectionMatrix;

attribute highp vec4 Vertex DCC(: POSITION);

attribute mediump vec2 texcoord0 DCC(: TEXCOORD0);

attribute lowp vec3 Color DCC(: COLOR0);

#if defined(UV_SCALE_OFFSET) || defined(UV_SCALE_OFFSET0)
	uniform mediump vec4 texcoord0_scaleoffset;
#endif

varying mediump vec2 vTexCoord0 DCC(: TEXCOORD0);

varying lowp vec4 vColor DCC(: COLOR0);

#ifdef FG
	varying lowp float vFogFactor;
	uniform mediump vec2 fogstartend;
	uniform highp mat4 matWorldViewT;
#endif

void main()
{
	vTexCoord0 = texcoord0.xy;
	vColor.rgb = Color;
	
	vColor.a = Color.r
#ifdef GLOBALFADE
	* GlobalFade
#endif
	;

#if defined(UV_SCALE_OFFSET) || defined(UV_SCALE_OFFSET0)
	vTexCoord0 = vTexCoord0 * texcoord0_scaleoffset.xy + texcoord0_scaleoffset.zw;
#endif

#ifdef FG
	float fogDistance = dot(matWorldViewT[2], Vertex);
	vFogFactor = clamp((-fogDistance - fogstartend[0]) / (fogstartend[1] - fogstartend[0]), 0.0, 1.0);
#endif

	gl_Position = WorldViewProjectionMatrix * Vertex;
}
