uniform mediump sampler2D texture0;

varying mediump vec2 vCoord0;
varying mediump vec2 vCoord1;
varying mediump vec2 vCoord2;
varying mediump vec2 vCoord3;

varying lowp vec3 vColor;

//Just like for bloom, we need to change to mediump for color calculation...
//Simply changing to mediump more then doubles the cycle count (15 to 34).

//To reduce the cycle counts we:
//- removed 1 sample
//- removed the weights

//this puts us a 20 (+5) cycles

void main()
{
	mediump vec4 color = texture2D(texture0, vCoord0);
	
	color += texture2D(texture0, vCoord1);
	color += texture2D(texture0, vCoord2);
	color += texture2D(texture0, vCoord3);
	
	color *= 0.25;

	gl_FragColor = color;
}

