attribute highp   vec4 Vertex;
attribute mediump vec2 TexCoord0;

uniform mediump	float center_x;
uniform mediump	float center_y;
uniform	mediump float deadzone;
uniform mediump	float scale;

varying mediump vec2 vCoord0;
varying mediump vec2 vCoord1;
varying mediump vec2 vCoord2;
varying mediump vec2 vCoord3;

uniform highp vec4 scaleoffset;

void main(void)
{
	vCoord0 = TexCoord0 * scaleoffset.xy + scaleoffset.zw;
	
	// calculate towards the center
	mediump vec2 center = vec2(center_x, center_y) * scaleoffset.xy + scaleoffset.zw;
	mediump vec2 dir = vCoord0 - center;
	mediump float l = length(dir);
	l = max(0.0, l-deadzone);
	mediump float weightedScale = scale * l;
	
	mediump float offset = 1.0 - weightedScale;
	
	vCoord1 = center + (dir * offset);
	offset -= weightedScale;
	vCoord2 = center + (dir * offset);
	offset -= weightedScale;
	vCoord3 = center + (dir * offset);

	gl_Position = Vertex;
}
