uniform lowp mat4 ColorMatrix; // Android

#ifdef DCC_MAX
	#define DCC(x) x
#else
	#define DCC(x)
#endif

uniform sampler2D DiffSampler;
uniform sampler2D DiffSampler_alpha; // Android

#ifdef USE_MASK
uniform sampler2D MaskSampler;
#endif

// Varyings
varying mediump vec2 vCoord0 DCC(: TEXCOORD0);
varying mediump vec2 vCoord1 DCC(: TEXCOORD1);

void main()
{
#ifdef USE_MASK
    mediump vec4 DiffuseColor = texture2D(DiffSampler, vCoord1.xy);
    mediump vec4 MaskColor = texture2D(MaskSampler, vCoord0.xy);

    gl_FragColor = MaskColor + DiffuseColor * MaskColor.a;
#else // USE_MASK
    //mediump vec4 DiffuseColor = texture2D(DiffSampler, vCoord0.xy); // Android
	mediump vec4 DiffuseColor = vec4( texture2D(DiffSampler, vCoord0.xy).rgb, texture2D(DiffSampler_alpha, vCoord0.xy).g ) ; // Android
    gl_FragColor = DiffuseColor;
#endif // USE_MASK
}
