#ifdef DCC_MAX
	#define DCC(x) x
#else
	#define DCC(x)
#endif

attribute highp vec4 Vertex DCC(: POSITION);

attribute mediump vec2 texcoord0 DCC(: TEXCOORD0);

varying mediump vec2 vTexCoord0;

#ifdef DCC_MAX
	attribute lowp    vec3 Color DCC(: TEXCOORD1);
	attribute lowp    float Alpha DCC(: TEXCOORD2);
#else
	attribute lowp    vec4 Color;
#endif

uniform lowp float SunOcclusionFactor;
varying lowp float vSunOcclusionFactor;

uniform highp mat4 matWorldViewProjection;

void main()
{	
	gl_Position = matWorldViewProjection * Vertex;
	
	vTexCoord0 = texcoord0;

	vSunOcclusionFactor = SunOcclusionFactor;
}
