uniform lowp mat4 ColorMatrix; // Android

#ifdef DCC_MAX
	#define DCC(x) x
#else
	#define DCC(x)
#endif

//#define FG

//#ifdef AB
//	#undef FG
//#endif

#if defined AT
	uniform lowp float alpharef;
#endif

varying mediump vec2 vTexCoord0 DCC(: TEXCOORD0);
varying mediump vec2 vTexCoord1 DCC(: TEXCOORD1);

uniform lowp sampler2D DiffuseSampler;
uniform lowp sampler2D DiffuseSampler_alpha; // Android

#if defined (AL) || defined (AB)
	uniform lowp float Object_Alpha;
#endif

uniform lowp vec3 lmpercentage0;
uniform lowp sampler2D LightMapSampler;
uniform lowp float lmboost;

#ifdef FG
	varying lowp float vFogFactor;
	uniform lowp vec4 fogcolor;   
#endif
#define TONED
#ifdef TONED
	uniform lowp vec3 ToneGain;
	uniform lowp vec3 ToneOffset;
#endif

 // main procedure, the original name was f
void main()
{	
	lowp vec4 Diffuse = texture2D(DiffuseSampler, vTexCoord0);	
	
#ifdef AT
	if (Diffuse.w < alpharef) discard;	
#endif

	lowp vec4 color = Diffuse;

	lowp vec3 lmcolor = texture2D(LightMapSampler, vTexCoord1).rgb * lmpercentage0;
	
	lowp float power = pow(1.0 + (lmcolor.x + lmcolor.y + lmcolor.z) * 0.3333, lmboost);
	lmcolor *= power;
	color.rgb *= lmcolor;

#ifdef AL
	color.a *= Object_Alpha;
#endif

#ifdef AB
	color.rgb *= Object_Alpha;
#endif
	
#ifdef FG
	color.xyz = mix(color.xyz, fogcolor.xyz, vFogFactor);
#endif

#ifdef TONED	
	color.rgb = color.rgb * ToneGain + ToneOffset;
#endif
	color.a = texture2D(DiffuseSampler_alpha, vTexCoord0).g;	// android flash lights
	gl_FragColor = clamp(color, 0.0, 1.0);
} // main end
