#ifdef GL_FRAGMENT_PRECISION_HIGH
	// define maxp based on user preference
	#ifdef GLITCH_USE_HIGHP
		#define MAXP highp
	#else
		#define MAXP mediump
	#endif
#else
	// force maxp as medium
	#define MAXP mediump

	// don't use bias, even if the user specify it, unless he/she explicitly force it
	#ifdef GLITCH_FORCE_USE_BIAS
		#ifndef GLITCH_USE_BIAS
			#define GLITCH_USE_BIAS
		#endif
	#else
		#ifdef GLITCH_USE_BIAS
			#undef GLITCH_USE_BIAS
		#endif
	#endif
#endif

#ifdef GLITCH_USE_BIAS
	#define TEXTURE2D(sampler, coord, bias) texture2D(sampler, coord, bias)
#else
	#define TEXTURE2D(sampler, coord, bias) texture2D(sampler, coord)
#endif

uniform lowp sampler2D Sampler0;
varying MAXP vec2 vTexCoord0;

#ifdef GLITCH_USE_BIAS
uniform mediump float Sampler0_bias;
#endif

varying lowp vec4 vColor0;

#ifdef FG
	varying lowp float vFogFactor;
	uniform lowp vec4 fogcolor;   
#endif

void main()
{
	lowp vec4 color = vColor0;

	color *= TEXTURE2D(Sampler0, vTexCoord0, Sampler0_bias);

	#ifdef FG
			color.xyz = mix(color.xyz, fogcolor.xyz, vFogFactor);
	#endif // FG

	gl_FragColor = color;
}
