uniform lowp mat4 ColorMatrix; // Android

#ifdef DCC_MAX
	#define DCC(x) x
#else
	#define DCC(x)
#endif

//#define FG

#if defined AT
	uniform lowp float alpharef;
#endif

varying mediump vec2 vTexCoord0;

#if defined (AL) || defined (AB)
	#ifdef VERTEX_COLOR
		varying lowp vec4 vColorAlpha;
	#else
		varying lowp float vAlpha;
	#endif
#endif

uniform lowp sampler2D DiffuseSampler;
uniform lowp sampler2D DiffuseSampler_alpha; // Android

#ifdef FG
	varying lowp float vFogFactor;
	uniform lowp vec4 fogcolor;   
#endif

#define TONED	
#ifdef TONED
	uniform lowp vec3 ToneGain;
	uniform lowp vec3 ToneOffset;
#endif

void main()
{
	//lowp vec4 Diffuse = texture2D(DiffuseSampler, vTexCoord0); // Android
	lowp vec4 Diffuse = vec4( texture2D(DiffuseSampler, vTexCoord0).rgb, texture2D(DiffuseSampler_alpha, vTexCoord0).g ) ; // Android

#ifdef AT
	if (Diffuse.w < alpharef) discard;	
#endif

	lowp vec4 color = Diffuse;

#ifdef AL
	#ifdef VERTEX_COLOR
		color *= vColorAlpha;
	#else
		color.a *= vAlpha;
	#endif
#endif
//@Marlon para que funcione la parte de abajo tuve que agregarle el #ifdef Vertex_color checa si no esta eso en iphone, el error es que si estaba activado ab y vertex_color vAlpha no existia
#ifdef AB
	#ifdef VERTEX_COLOR
		color *= vColorAlpha;
	#else
		color.rgb *= vAlpha;
	#endif
#endif
	
#ifdef FG
#ifdef AB
	color.xyz = mix(color.xyz, vec3(0.0, 0.0, 0.0), vFogFactor);
	color.a = mix(color.a, 1.0, vFogFactor);
#else // AB
	color.xyz = mix(color.xyz, fogcolor.xyz, vFogFactor);
#endif // AB
#endif // FG

#ifdef TONED
	#ifdef AB
		color.rgb = color.rgb * ToneGain;
	#else
		color.rgb = color.rgb * ToneGain + ToneOffset;
	#endif
#endif

	gl_FragColor = color;
} // main end
